"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileObserver = void 0;
const tslib_1 = require("tslib");
const fs_1 = tslib_1.__importDefault(require("fs"));
// import * as walk from 'walk';
const path_1 = tslib_1.__importDefault(require("path"));
class FileObserver {
    constructor(dirPath, filter) {
        Object.defineProperty(this, "dir", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "files", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Map()
        });
        Object.defineProperty(this, "filter", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.dir = dirPath;
        this.filter = filter;
    }
    walk() {
        return new Promise((res, rej) => {
            var changedFiles = [];
            this.getFiels(this.dir, changedFiles, rej);
            res(changedFiles);
            // var walker = walk.walk(this.dir);
            // walker.on("file", (root, stat, next) => {
            //     var filePath = path.join(root, stat.name);
            //     var relativePath = path.relative(this.dir, filePath);
            //     if (this.filter && !this.filter(relativePath, filePath, stat)) {
            //         next();
            //         return;
            //     }
            //     var millis = stat.mtime.getTime();
            //     if (this.files.has(filePath) && this.files.get(filePath)
            //         == millis) {
            //         next();
            //         return;
            //     }
            //     this.files.set(filePath, millis);
            //     changedFiles.push(relativePath);
            //     next();
            // })
            // walker.on("end", () => {
            //     res(changedFiles);
            // });
            // walker.on("nodeError", err => {
            //     rej(err);
            // })
        });
    }
    getFiels(rootPath, fileList, rej) {
        let files = fs_1.default.readdirSync(rootPath, { withFileTypes: true });
        files.filter((f) => {
            var filePath = path_1.default.join(rootPath, f.name);
            // console.log(filePath + ":" + this.filter(null, filePath, null))
            return this.filter(null, filePath, null);
        }).forEach((f) => {
            let filePath = path_1.default.join(rootPath, f.name);
            let relativePath = path_1.default.relative(this.dir, filePath);
            if (f.isDirectory()) {
                // console.log("目录：" + f.name)
                this.getFiels(filePath, fileList, rej);
            }
            else if (f.isFile()) {
                // console.log("文件：" + f.name)
                fileList.push(relativePath);
            }
            else {
                // console.log("未知类型：" + f.name)
            }
        });
    }
}
exports.FileObserver = FileObserver;
