/// <reference types="node" />
/// <reference types="node" />
import { EventEmitter } from 'events';
import ws from 'websocket';
import { DeviceClient } from '@devicefarmer/adbkit';
import ADBDevice from '@devicefarmer/adbkit/dist/src/Device';
import { Project, ProjectObserser } from './project';
export declare class Device extends EventEmitter {
    name: string;
    type: string;
    id: string;
    private connection?;
    attached: boolean;
    projectObserser: ProjectObserser;
    constructor(connection: ws.connection, type: string, id: string);
    close(): void;
    send(type: string, data: any): void;
    sendBytes(bytes: Buffer): void;
    sendBytesCommand(command: string, md5: string, data?: object): void;
    sendCommand(command: string, data: object): void;
    toString: () => string;
    private read;
}
export declare class AutoJsDebugServer extends EventEmitter {
    isHttpServerStarted: boolean;
    private httpServer;
    adbClient: import("@devicefarmer/adbkit").Client;
    private tracker?;
    readonly port: number;
    devices: Array<Device>;
    project?: Project | null;
    private fileFilter;
    constructor(port?: number);
    getDeviceById(id: string): Device | undefined;
    private newDevice;
    adbShell(device: DeviceClient, command: string): Promise<string>;
    private connectAutoxjsByADB;
    listen(): void;
    listADBDevices(): Promise<ADBDevice[]>;
    trackADBDevices(): Promise<void>;
    connectDevice(id: string, device?: DeviceClient): Promise<void>;
    private listForwards;
    stopTrackADBDevices(): void;
    send(type: string, data: any): void;
    sendBytes(data: Buffer): void;
    sendBytesCommand(command: string, md5: string, data?: object): void;
    sendProjectCommand(folder: string, command: string): void;
    sendCommand(command: string, data?: object): void;
    disconnect(): void;
    /** 获取本地IP */
    getIPAddress(): string | undefined;
    /** 获取本地IP */
    getIPs(): string[];
    /** 获取服务运行端口 */
    getPort(): number;
    private attachDevice;
    /** 分离设备? */
    private detachDevice;
}
