/// <reference types="node" />
/// <reference types="node" />
import { FileFilter } from "./diff";
import * as fs from "fs";
export interface obj {
    [key: string]: any;
}
export declare class Project {
    config: ProjectConfig;
    fpath: string;
    fileFilter: (relativePath: string, absPath: string, stats: fs.Stats) => boolean;
    constructor(configPath: string, config: obj);
    dispose(): void;
}
export declare class ProjectObserser {
    folder: string;
    private fileObserver;
    private fileFilter;
    constructor(folder: string, filter: FileFilter);
    diff(): Promise<{
        buffer: Buffer;
        md5: string;
    }>;
    zip(): Promise<{
        buffer: Buffer;
        md5: string;
    }>;
}
export declare class LaunchConfig {
    hideLogs: boolean;
}
export declare class ProjectConfig {
    name: string;
    icon: string;
    packageName: String;
    main: String;
    versionCode: number;
    versionName: string;
    ignore: string[];
    launchConfig: LaunchConfig;
    save(path: string): Promise<unknown>;
    static fromJson(text: string): ProjectConfig;
    static fromJsonFile(config: obj): ProjectConfig;
}
